module Gem
  class << self

    ##
    # For each location provides set of directories for binaries (:bin_dir)
    # platform independent (:gem_dir) and dependent (:ext_dir) files.

    def default_dirs
      @default_dirs ||= Hash[[:system, :local].collect do |destination|
        [destination, {
          :bin_dir => ConfigMap[:bindir],
          :gem_dir => File.join(ConfigMap[:vendordir].split(File::SEPARATOR), 'gems', ConfigMap[:ruby_version]),
          :ext_dir => File.join(ConfigMap[:vendordir].split(File::SEPARATOR), 'gems', ConfigMap[:ruby_version])
        }]
      end]
    end

    ##
    # RubyGems default overrides.

    def default_dir
      Gem.default_dirs[:local][:gem_dir]
    end

    def default_path
      path = default_dirs.collect {|location, paths| paths[:gem_dir]}
    end

    def default_bindir
      Gem.default_dirs[:local][:bin_dir]
    end

    def default_ext_dir_for base_dir
      dirs = Gem.default_dirs.detect {|location, paths| paths[:gem_dir] == base_dir}
      dirs && File.join(dirs.last[:ext_dir], 'exts')
    end
  end
end
